<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - File Set</TITLE>
<link href="suif1_9.html" rel=Next>
<link href="suif1_7.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_7.html">previous</A>, <A HREF="suif1_9.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC8" HREF="suif1_toc.html#TOC8">The File Set</A></H2>
<P>
<A NAME="IDX5"></A>

</P>
<P>
<A NAME="IDX6"></A>
<A NAME="IDX7"></A>
<A NAME="IDX8"></A>
<A NAME="IDX9"></A>
<A NAME="IDX10"></A>
The file set, which contains a list of file set entries, is implemented
by the <CODE>file_set</CODE> class.  The list of files can be accessed
directly using the <CODE>file_list</CODE> method, but most users will not need
to do that because other methods are available to perform the common
operations.  The <CODE>add_file</CODE> method adds a new file set entry to the
list.  This method takes the names of the input file and output file and
returns the new file set entry.  Either the input file or the output
file may be <CODE>NULL</CODE>.  The <CODE>file_set</CODE> class also contains an
iterator, as most SUIF programmers will want to iterate through the list
of files.  The <CODE>reset_iter</CODE> method resets the iterator to the first
file set entry.  The <CODE>next_file</CODE> method returns the next file set
entry in the list.

</P>
<P>
<A NAME="IDX11"></A>
Besides the list of files, the file set also contains the global symbol
table (see section <A HREF="suif1_42.html#SEC42">The Global Symbol Table</A>) which can be accessed using the
<CODE>globals</CODE> method.  This symbol table contains the symbols and types
that are visible in all of the source files.  Before a group of files
can be combined into a file set, their global symbol tables must be
merged together.  A separate SUIF linker is provided for this purpose.
The library will complain if the files in the file set have not been
properly linked.

</P>
<P>
<A NAME="IDX12"></A>
Currently, only one file set is allowed per SUIF program.  This
restriction was made so that predefined types could be entered into the
global symbol table at initialization time.  See section <A HREF="suif1_68.html#SEC68">Predefined Types</A>.
If multiple file sets were permitted, these predefined types would be
duplicated.  A single global file set is created when the SUIF library
is initialized; the <CODE>fileset</CODE> global variable points to this file
set.

</P>
<P>
All of the low-level access to SUIF files is performed automatically by
the library.  The global and file symbol tables are read from the input
files when they are added to the file set.  Users can then read and
write individual procedure bodies using methods on the procedure symbols
(see section <A HREF="suif1_53.html#SEC53">Procedure Symbols</A>).  The global symbol tables are not written
out until the file set is destroyed.  Throughout this process, the file
set keeps track of the number of open files in order to avoid exceeding
the OS limit.  If there are too many files open at once, the file set
will automatically find one to close.  This is totally invisible to
users.  Files that are temporarily closed are automatically reopened as
needed.

</P>
<P>
As an example of using the file set, the following code reads in the
files <CODE>infile1</CODE> and <CODE>infile2</CODE> and writes them out to
<CODE>outfile1</CODE> and <CODE>outfile2</CODE>, respectively, after processing them
with the user-defined routine <CODE>process_file</CODE>.

</P>

<PRE>
fileset-&#62;add_file("infile1", "outfile1");
fileset-&#62;add_file("infile2", "outfile2");

file_set_entry *fse;

fileset-&#62;reset_iter();
while (fse = fileset-&#62;next_file()) {
    process_file(fse);
}

delete fileset;
</PRE>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_7.html">previous</A>, <A HREF="suif1_9.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
